// ============================================================================
// mouse.h
// ----------------------------------------------------------------------------
// (c) 2006-2023 by HerzAusGold
//               Hubert Haberkorn
//               herz-aus-gold-42@gmx.de
//               http://www.arthurdent.de/
// ----------------------------------------------------------------------------
// The above copyright notice and this permission notice 
// shall be included in all copies or substantial portions 
// of the Software.
// ----------------------------------------------------------------------------
// handle mouse option and mouse.conf (header)
// ============================================================================

#ifndef MOUSE_H
#define MOUSE_H

#include <stdlib.h>
#include <stdio.h>

#include "system.h"


/*---#HAG#mouse#--->*/
#define MOUSEMODE_OFF            0
/*  1     : LEFT = run to empty space  RIGHT = run to dig,collect place */
#define MOUSEMODE_SOKO_SNOKO1    1
#define MOUSEMODE_SOKO_SNOKO2    2
#define MOUSEMODE_SOKO_SNOKO3    3
/* 11     : RIGHT = with follow mouse */
#define MOUSEMODE_FOLLOW1       11
#define MOUSEMODE_FOLLOW2       12
#define MOUSEMODE_FOLLOW3       13
/* 21     : with SNAP           */
#define MOUSEMODE_FOLLOWSNAP1   21
#define MOUSEMODE_FOLLOWSNAP2   22
#define MOUSEMODE_FOLLOWSNAP3   23
/* 31     : direct follow mouse */
#define MOUSEMODE_DIRDIFF       31
/* 41     : LEFT = move RIGHT = snap */
#define MOUSEMODE_SNOKOSNAP1    41
#define MOUSEMODE_SNOKOSNAP2    42
#define MOUSEMODE_SNOKOSNAP3    43
#define MOUSEMODE_SNOKOSNAP4    44
#define MOUSEMODE_SNOKOSNAP5    45
#define MOUSEMODE_SNOKOSNAP6    46
#define MOUSEMODE_SNOKOSNAP7    47
#define MOUSEMODE_SNOKOSNAP8    48
#define MOUSEMODE_SNOKOSNAP9    49

/*-- internal modes --*/
// MouseHandleMove
#define MHM_DIRDIFF         1
#define MHM_SNOKO           2
// MouseHandleButton
#define MHB_SOKO_SNOKO      1
#define MHB_DIRSNAP         2
#define MHB_SNOKOSNAP       3

// snoko modes
#define SNOKOMODE_SMALL     1     /* calc without check */
#define SNOKOMODE_DIRECT    2     /* without calc       */

// mouse conf
#define MOUSE_TOKEN_MODE              "mouse_mode"
#define MOUSE_TOKEN_FOLLOWMOUSE       "mouse_follow"
#define MOUSE_TOKEN_MOUSEHANDLEMOVE   "mouse_handlemove"
#define MOUSE_TOKEN_MOUSEHANDLEBUTTON "mouse_handlebutton"
#define MOUSE_TOKEN_LEARN             "mouse_learn"
#define MOUSE_TOKEN_LEARNPAUSE        "mouse_learnpause"
#define MOUSE_TOKEN_DIRECTMOVE        "mouse_directmove"
#define MOUSE_TOKEN_SOKOMODE          "mouse_sokomode"
#define MOUSE_TOKEN_SNOKOMODE         "mouse_snokomode"
#define MOUSE_TOKEN_FRAMEDELAY        "mouse_framedelay"

/*<---#HAG#mouse#---*/

/*--#HAG#mouse#--*/
void calcMouseOption (long i_mode); 
void SetupMouseOptionFromConf (char *basedir, char* filename);


#endif
